<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>jetset.base_model &#8212; jetset 1.0.a documentation</title>
    <link rel="stylesheet" href="../../_static/bootstrap-sphinx.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../../',
        VERSION:     '1.0.a',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true,
        SOURCELINK_SUFFIX: '.txt'
      };
    </script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <script type="text/javascript" src="../../_static/js/jquery-1.11.0.min.js"></script>
    <script type="text/javascript" src="../../_static/js/jquery-fix.js"></script>
    <script type="text/javascript" src="../../_static/bootstrap-3.3.7/js/bootstrap.min.js"></script>
    <script type="text/javascript" src="../../_static/bootstrap-sphinx.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
<meta charset='utf-8'>
<meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
<meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1'>
<meta name="apple-mobile-web-app-capable" content="yes">

  </head>
  <body>

  <div id="navbar" class="navbar navbar-inverse navbar-default navbar-fixed-top">
    <div class="container">
      <div class="navbar-header">
        <!-- .btn-navbar is used as the toggle for collapsed navbar content -->
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".nav-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="../../index.html"><span><img src="../../_static/logo_small_transp.png"></span>
          JetSeT</a>
        <span class="navbar-text navbar-version pull-left"><b>1.0</b></span>
      </div>

        <div class="collapse navbar-collapse nav-collapse">
          <ul class="nav navbar-nav">
            
            
              <li class="dropdown globaltoc-container">
  <a role="button"
     id="dLabelGlobalToc"
     data-toggle="dropdown"
     data-target="#"
     href="../../index.html">JetSeT <b class="caret"></b></a>
  <ul class="dropdown-menu globaltoc"
      role="menu"
      aria-labelledby="dLabelGlobalToc"><ul>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/user_guide.html">user guide</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../user_guide/user_guide.html#content">Content</a></li>
</ul>
</li>
</ul>
</ul>
</li>
              
                <li class="dropdown">
  <a role="button"
     id="dLabelLocalToc"
     data-toggle="dropdown"
     data-target="#"
     href="#">Page <b class="caret"></b></a>
  <ul class="dropdown-menu localtoc"
      role="menu"
      aria-labelledby="dLabelLocalToc"></ul>
</li>
              
            
            
              
                
              
            
            
            
            
              <li class="hidden-sm"></li>
            
          </ul>

          
            
<form class="navbar-form navbar-right" action="../../search.html" method="get">
 <div class="form-group">
  <input type="text" name="q" class="form-control" placeholder="Search" />
 </div>
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form>
          
        </div>
    </div>
  </div>

<div class="container">
  <div class="row">
      <div class="col-md-3">
        <div id="sidebar" class="bs-sidenav" role="complementary">
<form action="../../search.html" method="get">
 <div class="form-group">
  <input type="text" name="q" class="form-control" placeholder="Search" />
 </div>
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form>
        </div>
      </div>
    <div class="col-md-9 content">
      
  <h1>Source code for jetset.base_model</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">__future__</span> <span class="k">import</span> <span class="n">absolute_import</span><span class="p">,</span> <span class="n">division</span><span class="p">,</span> <span class="n">print_function</span>

<span class="kn">from</span> <span class="nn">builtins</span> <span class="k">import</span> <span class="p">(</span><span class="nb">bytes</span><span class="p">,</span> <span class="nb">str</span><span class="p">,</span> <span class="nb">open</span><span class="p">,</span> <span class="nb">super</span><span class="p">,</span> <span class="nb">range</span><span class="p">,</span>
                      <span class="nb">zip</span><span class="p">,</span> <span class="nb">round</span><span class="p">,</span> <span class="nb">input</span><span class="p">,</span> <span class="nb">int</span><span class="p">,</span> <span class="nb">pow</span><span class="p">,</span> <span class="nb">object</span><span class="p">,</span> <span class="nb">map</span><span class="p">,</span> <span class="nb">zip</span><span class="p">)</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="s2">&quot;Andrea Tramacere&quot;</span>


<span class="kn">from</span> <span class="nn">.model_parameters</span> <span class="k">import</span> <span class="n">ModelParameterArray</span><span class="p">,</span> <span class="n">ModelParameter</span>
<span class="kn">from</span> <span class="nn">.spectral_shapes</span> <span class="k">import</span> <span class="n">SED</span>
<span class="kn">from</span> <span class="nn">.data_loader</span> <span class="k">import</span>  <span class="n">ObsData</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>

<span class="n">__all__</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;Model&#39;</span><span class="p">]</span>
<div class="viewcode-block" id="Model"><a class="viewcode-back" href="../../api/jetset.base_model.Model.html#jetset.base_model.Model">[docs]</a><span class="k">class</span> <span class="nc">Model</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    
    
    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">name</span><span class="o">=</span><span class="s1">&#39;no-name&#39;</span><span class="p">,</span><span class="n">nu_size</span><span class="o">=</span><span class="mi">100</span><span class="p">):</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">model_type</span><span class="o">=</span><span class="kc">None</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="o">=</span><span class="n">name</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">SED</span> <span class="o">=</span> <span class="n">SED</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">)</span>
    
        <span class="bp">self</span><span class="o">.</span><span class="n">parameters</span> <span class="o">=</span> <span class="n">ModelParameterArray</span><span class="p">()</span>    
        
        <span class="bp">self</span><span class="o">.</span><span class="n">_scale</span><span class="o">=</span><span class="s1">&#39;lin-lin&#39;</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">nu_size</span><span class="o">=</span><span class="n">nu_size</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">nu_min</span><span class="o">=</span><span class="kc">None</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">nu_max</span><span class="o">=</span><span class="kc">None</span>
        
        
   
<div class="viewcode-block" id="Model.eval"><a class="viewcode-back" href="../../api/jetset.base_model.Model.html#jetset.base_model.Model.eval">[docs]</a>    <span class="k">def</span> <span class="nf">eval</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">fill_SED</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span><span class="n">nu</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span><span class="n">get_model</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span><span class="n">loglog</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span><span class="n">plot</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span><span class="n">label</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        
        <span class="k">if</span> <span class="n">nu</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="c1">#print(&quot;---&gt;&quot;, self.nu_min,self.nu_max,self.nu_size)</span>
            
            <span class="n">x1</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nu_min</span><span class="p">)</span>

            <span class="n">x2</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nu_max</span><span class="p">)</span>
            
            <span class="n">lin_nu</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">logspace</span><span class="p">(</span><span class="n">x1</span><span class="p">,</span><span class="n">x2</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">nu_size</span><span class="p">)</span>
            
            <span class="n">model</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">(</span><span class="n">lin_nu</span><span class="o">.</span><span class="n">size</span><span class="p">)</span>
            <span class="c1">#print &quot;x1&quot;,x1     </span>
            
            
        <span class="k">else</span><span class="p">:</span>
            

            <span class="k">if</span> <span class="n">np</span><span class="o">.</span><span class="n">shape</span><span class="p">(</span><span class="n">nu</span><span class="p">)</span><span class="o">==</span><span class="p">():</span>
 
                <span class="n">nu</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">nu</span><span class="p">])</span>
            
            
            
           
            
        <span class="k">if</span> <span class="n">loglog</span><span class="o">==</span><span class="kc">False</span><span class="p">:</span>
            <span class="n">log_nu</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">nu</span><span class="p">)</span>
            
            <span class="n">lin_nu</span><span class="o">=</span><span class="n">nu</span>
            
            <span class="n">model</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">lin_func</span><span class="p">(</span><span class="n">lin_nu</span><span class="p">)</span>
        
        <span class="k">else</span><span class="p">:</span>
            <span class="n">log_nu</span><span class="o">=</span><span class="n">nu</span>

            <span class="n">lin_nu</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">power</span><span class="p">(</span><span class="mf">10.</span><span class="p">,</span><span class="n">log_nu</span><span class="p">)</span>
    
            <span class="n">log_model</span><span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">log_func</span><span class="p">(</span><span class="n">log_nu</span><span class="p">)</span>
            
            <span class="n">model</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">power</span><span class="p">(</span><span class="mf">10.</span><span class="p">,</span><span class="n">log_model</span><span class="p">)</span>
        
        
        <span class="k">if</span> <span class="n">fill_SED</span><span class="o">==</span><span class="kc">True</span><span class="p">:</span>
            <span class="c1">#print &quot;base model&quot;, self.model_type,self.nu_min,self.nu_max</span>
            <span class="c1">#print lin_nu[0]</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">SED</span><span class="o">.</span><span class="n">fill</span><span class="p">(</span><span class="n">nu</span><span class="o">=</span><span class="n">lin_nu</span><span class="p">,</span><span class="n">nuFnu</span><span class="o">=</span><span class="n">model</span><span class="p">)</span>
        
        
        <span class="c1">#print model[0]</span>
        
        <span class="k">if</span> <span class="n">plot</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">label</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">label</span><span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span>
                    
                <span class="bp">self</span><span class="o">.</span><span class="n">PlotModel</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="n">clean</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">)</span>
        
        <span class="k">if</span> <span class="n">get_model</span><span class="o">==</span><span class="kc">True</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">loglog</span><span class="o">==</span><span class="kc">False</span><span class="p">:</span>
            
                <span class="k">return</span> <span class="n">model</span>
            <span class="k">else</span><span class="p">:</span>
                
                <span class="k">return</span> <span class="n">log_model</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">None</span></div>
        
<div class="viewcode-block" id="Model.PlotModel"><a class="viewcode-back" href="../../api/jetset.base_model.Model.html#jetset.base_model.Model.PlotModel">[docs]</a>    <span class="k">def</span> <span class="nf">PlotModel</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">Plot</span><span class="p">,</span><span class="n">clean</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span><span class="n">label</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="c1">#print &quot;PlotModel base model&quot;</span>
        <span class="k">if</span> <span class="n">Plot</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">clean</span><span class="o">==</span><span class="kc">True</span><span class="p">:</span>
                <span class="n">Plot</span><span class="o">.</span><span class="n">clean_model_lines</span><span class="p">()</span>
           
            <span class="k">if</span> <span class="n">label</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">label</span><span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span>
           
            <span class="n">Plot</span><span class="o">.</span><span class="n">add_model_plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">SED</span><span class="p">,</span><span class="n">autoscale</span><span class="o">=</span><span class="n">autoscale</span><span class="p">,</span><span class="n">line_style</span><span class="o">=</span><span class="s1">&#39;-&#39;</span><span class="p">,</span><span class="n">label</span><span class="o">=</span><span class="n">label</span><span class="p">)</span>
        
            <span class="c1">#print self.SED.nu</span>
            
            
        <span class="k">else</span><span class="p">:</span>
            <span class="nb">print</span> <span class="p">(</span><span class="s2">&quot;the plot window is not defined&quot;</span><span class="p">)</span></div>
            
<div class="viewcode-block" id="Model.set_nu_grid"><a class="viewcode-back" href="../../api/jetset.base_model.Model.html#jetset.base_model.Model.set_nu_grid">[docs]</a>    <span class="k">def</span> <span class="nf">set_nu_grid</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">nu_min</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span><span class="n">nu_max</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span><span class="n">nu_size</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">nu_size</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">nu_size</span><span class="o">=</span><span class="n">nu_size</span>
        
        <span class="k">if</span> <span class="n">nu_min</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">nu_min</span><span class="o">=</span><span class="n">nu_min</span>
        
        <span class="k">if</span> <span class="n">nu_max</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">nu_max</span><span class="o">=</span><span class="n">nu_max</span></div>
    
<div class="viewcode-block" id="Model.lin_func"><a class="viewcode-back" href="../../api/jetset.base_model.Model.html#jetset.base_model.Model.lin_func">[docs]</a>    <span class="k">def</span> <span class="nf">lin_func</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">nu</span><span class="p">):</span>
        <span class="k">pass</span>   </div>
    
<div class="viewcode-block" id="Model.log_func"><a class="viewcode-back" href="../../api/jetset.base_model.Model.html#jetset.base_model.Model.log_func">[docs]</a>    <span class="k">def</span> <span class="nf">log_func</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">log_nu</span><span class="p">):</span>
        <span class="k">pass</span></div>



<div class="viewcode-block" id="Model.get_residuals"><a class="viewcode-back" href="../../api/jetset.base_model.Model.html#jetset.base_model.Model.get_residuals">[docs]</a>    <span class="k">def</span> <span class="nf">get_residuals</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="n">log_log</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span><span class="n">filter_UL</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">data</span><span class="p">,</span><span class="n">ObsData</span><span class="p">):</span>
            <span class="n">data</span><span class="o">=</span><span class="n">data</span><span class="o">.</span><span class="n">data</span>

        <span class="n">model</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">eval</span><span class="p">(</span><span class="n">nu</span><span class="o">=</span><span class="n">data</span><span class="p">[</span><span class="s1">&#39;nu_data&#39;</span><span class="p">],</span> <span class="n">fill_SED</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">get_model</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">loglog</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

        <span class="c1"># print &quot;loglog&quot;,loglog</span>
        <span class="k">if</span> <span class="n">filter_UL</span> <span class="o">==</span><span class="kc">True</span><span class="p">:</span>
            <span class="n">msk</span><span class="o">=</span><span class="n">data</span><span class="p">[</span><span class="s1">&#39;UL&#39;</span><span class="p">]</span><span class="o">==</span><span class="kc">False</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">msk</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">(</span><span class="n">data</span><span class="o">.</span><span class="n">size</span><span class="p">,</span><span class="n">dt</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

        <span class="n">residuals</span> <span class="o">=</span> <span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s1">&#39;nuFnu_data&#39;</span><span class="p">]</span> <span class="o">-</span> <span class="n">model</span><span class="p">)</span> <span class="o">/</span>  <span class="n">data</span><span class="p">[</span><span class="s1">&#39;dnuFnu_data&#39;</span><span class="p">]</span>

        <span class="n">nu_residuals</span><span class="o">=</span><span class="n">data</span><span class="p">[</span><span class="s1">&#39;nu_data&#39;</span><span class="p">]</span>


        <span class="k">if</span> <span class="n">log_log</span> <span class="o">==</span> <span class="kc">False</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">nu_residuals</span><span class="p">[</span><span class="n">msk</span><span class="p">],</span> <span class="n">residuals</span><span class="p">[</span><span class="n">msk</span><span class="p">]</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span>  <span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">nu_residuals</span><span class="p">[</span><span class="n">msk</span><span class="p">]),</span>  <span class="n">residuals</span><span class="p">[</span><span class="n">msk</span><span class="p">]</span></div></div>
</pre></div>

    </div>
      
  </div>
</div>
<footer class="footer">
  <div class="container">
    <p class="pull-right">
      <a href="#">Back to top</a>
      
    </p>
    <p>
        &copy; Copyright 2018, andrea tramacere.<br/>
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.6.6.<br/>
    </p>
  </div>
</footer>
  </body>
</html>